To run this code, please prepare a pretrained StyleGAN2 model (trained by Tensorflow 1.14) and a posterior distribution model. Both models need to be restored as .pkl files (see official StyleGAN2 code for how to do it).

Please make sure that you have correctly installed tensorflow-gpu-1.14, requests-2.22.0, scipy-1.3.3, pillow-6.2.1, and tqdm, and have a GPU with more than 12GB RAM.

Then, please enter the ipythonnotebook file 'PrincipalKnowledgeDescent.ipynb', and enter the correct paths for the 'pretrained_StyleGAN_pkl' and 'posterior_pkl' in the second code cell. Then excute each cell by turns, samples from the extrapolated distribution will be shown in the output of the last cell.